% This is the script to run Monto Carlo simulations


MC = 100; % number of MC simulations


% Arrays to store MC results
MSE_POS = zeros(1,MC);
MSE_VEL = zeros(1,MC);
ESS = zeros(1,MC);
TIME = zeros(1,MC);
TIME_OPT = zeros(1,MC);

fprintf('Start Monte Carlo simulations: \n');
for numMC = 1:MC
    
    if mod(numMC,20) == 0
        fprintf('%d, \n', numMC);
    else
        fprintf('%d,', numMC);
    end

%     mainCAPF;
    [MSEposition, MSEvelocity, meanESS, meanTime, meanTimeOpt] = mainCAPF(numMC);
    MSE_POS(1,numMC) = MSEposition;
    MSE_VEL(1,numMC) = MSEvelocity;
    ESS(1,numMC) = meanESS;
    TIME(1,numMC) = meanTime;
    TIME_OPT(1,numMC) = meanTimeOpt;
%     clearvars -except MSE_POS ESS SAM_TIMES TIME
end


index=find(~isnan(ESS));


sprintf('The mean of MSE position is: %f', mean(MSE_POS(index(1:100))))
std(MSE_POS(index(1:100)))
sprintf('The mean of MSE velocity is: %f', mean(MSE_VEL(index(1:100))))
sprintf('Average calculation time is: %f', mean(TIME(index(1:100))))
sprintf('Average ESS is: %f', mean(ESS(index(1:100))))

% sprintf('The mean of MSE position is: %f', mean(MSE_POS))
% std(MSE_POS)
% sprintf('The mean of MSE velocity is: %f', mean(MSE_VEL))
% sprintf('Average calculation time is: %f', mean(TIME))
% sprintf('Average ESS is: %f', mean(ESS))
