function [newpart, wnew, xest, info] = softConPF(k, xpartminus, wminus, yobv)

global Q;
global R;
global Beta;
global sigcon;
global sigbound;
global sigvel;

sigbound = sigcon(1); % for road boundary
sigvel = sigcon(3); % for speed limit

% ====== Initialisation ===================================================
ct = tic; % overall calculation time;
[n, N] = size(xpartminus); % sample size

xest = zeros(n,1);

rankQ = rank(Q);
cholQ = chol(Q);


%==========================================================================


xpartplus = fDyn(k,xpartminus); % x_k+1 = f(x_k)

% bound = gCon(xpartplus); 

%==========================================================================
xpartmode = xpartplus; % initialise the xplusmode (mode without constraints)
% probCon = ones(1,N);

% 
xpartnew = zeros(n,N);
gVal = zeros(length(sigcon),N);

% draw new sample from mode
for ii = 1:N
    xpartnew(:,ii) = xpartmode(:,ii) + cholQ*randn(rankQ,1);
    gVal(:,ii) = gCon(xpartnew(:,ii));

end
% =========================================================================


% % plot(xpartnew(1,:),xpartnew(2,:),'.');

update = ones(1,N); % update due to observation

% =========================================================================
% gVal = gCon(xpartnew);
% 
proInBound1 = ones(1,N);
proInBound2 = ones(1,N);
proInBound3 = ones(1,N);

for ii = 1:N
    proInBound1(ii) = myexpcdf(-gVal(1,ii),sigbound);
    proInBound2(ii) = myexpcdf(-gVal(2,ii),sigbound);
    proInBound3(ii) = myexpcdf(-gVal(3,ii),sigvel);
    update(ii) = mvnpdf(yobv, hObv(xpartnew(:,ii)), R);
end

logProIB1 = log(proInBound1);
logProIB2 = log(proInBound2);
logProIB3 = log(proInBound3);

% incon = proInBound1.*proInBound2.*proInBound3;
logIncon = logProIB1 + logProIB2 + logProIB3;
% =========================================================================


% update = likelihood(xpartnew,yobv,R);

logwplus = log(wminus) + log(update) + logIncon;

maxlogwplus = max(logwplus);

logwplus = logwplus - maxlogwplus;

% wplus = wminus .* update .*incon .* ratio; % 

wplus = exp(logwplus);

wplus = wplus/sum(wplus);
    

ess = ESS(wplus);

% ===================== Resampling ========================================

if ess/N <= Beta
    [newpart, wnew, ~] = resampling(xpartnew,wplus);
end



% =========================================================================

time = toc(ct); % overall calculation time;

% ============= Outputs ==================================================

xest = sum(newpart.*(ones(n,1)*wnew), 2);

info.ess = ess;
info.fitness = 0;
info.time = time;
info.timeOpt = 0;

% =======================================================================

end



function ess = ESS(w)

sumw2 = w*w';
ess = 1/sumw2;

end




